<template>
  <div class="modal-content" v-bind:class="{ hide: !Show }">
    <div class="modal-header">
      <div class="pull-left"><h4 class="modal-title">Analyzers &raquo; Rates &raquo; Edit</h4></div>
      <div class="pull-right btn-group">
        <button type="button" class="btn btn-default btn-xs" v-bind:class="{ disabled: (Error != '') }" v-on:click="Save"><img :src="require('Imgs/diskette.png')" alt="Save rate"></button>
        <button type="button" class="btn btn-default btn-xs" v-bind:class="{ disabled: (Error != '') }" v-on:click="Periods">Periods</button>
        <button type="button" class="btn btn-default btn-xs" v-bind:class="{ disabled: (Error != '') }" v-on:click="Billing">Billing</button>
        <button type="button" class="btn btn-default btn-xs" @click="Back"><img :src="require('Imgs/arrow_undo.png')" alt="Discard"></button>
      </div>
    </div>
    <div class="modal-body">
      <spinner v-if="ShowSpinner"></spinner>
      <div class="alert alert-danger text-center" style="margin-bottom: 5px; padding: 5px" v-if="Error != '' && !ShowSpinner">{{ Error }}</div>
      <div class="alert alert-success text-center" style="margin-bottom: 5px; padding: 5px" v-if="Error == '' && !ShowSpinner">{{ Rate.Template.Description }}<br><strong>Rate contains {{ Rate.Template.Seasons.length }}  seasons, a total of {{ Rate.Template.Periods.length }}  day periods and {{ Rate.Template.Holidays.length }} holidays</strong></div>
      <div class="row">
        <div class="col-xs-12">
          <label class="control-label">Base Tariff</label>
          <div class="input-group">
            <input type="text" class="form-control" ref="Base">
            <div class="input-group-btn">
              <button type="button" class="btn btn-default dropdown-toggle" data-toggle=""><span class="caret"></span></button>
              <ul class="dropdown-menu dropdown-menu-right" role="menu"></ul>
            </div>
          </div>
        </div>
        <div class="col-xs-12 col-sm-6"><label class="control-label">From</label><date-picker ref="StartDate" :options="{ format: 'DD/MM/YYYY', viewMode: 'months', timeZone: Analyzer.TimeZone }" v-on:DateChanged="SetStartDate"></date-picker></div>
        <div class="col-xs-12 col-sm-6"><label class="control-label">To</label><date-picker ref="EndDate" :options="{ format: 'DD/MM/YYYY', viewMode: 'months', timeZone: Analyzer.TimeZone }" v-on:DateChanged="SetEndDate"></date-picker></div>
      </div>              
    </div>
  </div>
</template>

<script>
  import bsSuggest from 'JS/bootstrap-suggest.js';
  import moment from 'JS/moment.js';
  import DatePicker from 'Components/DatePicker.vue';
  import Spinner from 'Components/Spinner.vue';
  export default {
    data() {
      return { Show: false, ShowSpinner: true, Rate: null, Error: '', Analyzer: null };
    },
    methods: {
      LoadCurrent: function() {
        $(this.$refs.Base).attr('data-id', 'CURRENT');
        $(this.$refs.Base).val(this.Tariffs[0].name);
        this.Rate.Template = Object.assign({}, this.Initial.Template);
        this.FillPeriods();
        this.Rate.Name = this.Initial.Name;
      },
      SetTariffs: function() {
        $(this.$refs.Base).bsSuggest("destroy");
        $(this.$refs.Base).bsSuggest( { hideOnSelect: true, effectiveFields: ['name', 'description'], showHeader: false, ignorecase: true, indexId: 0, indexKey: 1, data: { value: this.Tariffs } } );
        $(this.$refs.Base).on('onSetSelectValue', this.SelectBase.bind(this));
        $(this.$refs.Base).on('onUnsetSelectValue', this.DeselectBase.bind(this));
        if(this.Initial !== null) this.LoadCurrent();
        this.$refs.StartDate.SetDate(moment(this.Rate.StartDate));
        this.$refs.EndDate.SetDate(moment(this.Rate.EndDate));   
        this.Validate();
        this.ShowSpinner = false;
      },
      Save: function() {
        $.ajax({ url: (this.Rate.RateID == undefined) ? "addRate" : "setRate", timeout: 20000, type: "POST", dataType: "text", contentType: 'application/json', data: JSON.stringify( Object.assign({ Analyzer: this.Analyzer.Analyzer, CountryCode: 'ESP' /*this.Analyzer.CountryCode*/ }, this.Rate) ), 
          success: function() {
            this.Show = false;
            this.$parent.$refs.Rates.Load(this.Analyzer);
          }.bind(this),
          error: function() {
            this.Error = 'Failed to save rate to analyzer!';
            setTimeout(function() { this.Error = ''; }.bind(this), 1000); 
          }.bind(this)
        });
      },
      Load: function(analyzer, id) {
        this.Analyzer = analyzer;
        this.Show = true;
        this.ShowSpinner = true;
        this.Tariffs = [];
        this.$nextTick(function() {
          $.ajax({ url: "getTariffs", timeout: 20000, type: "POST", dataType: "json", contentType: 'application/json', data: JSON.stringify({ }), 
            success: function(result) {
              for(var i = 0; i < result.length; i++) this.Tariffs.push({ id: result[i].TariffID, name: result[i].Name, description: 'From ' + moment(result[i].StartDate).format('DD/MM/YYYY') + ' to ' + moment(result[i].EndDate).format('DD/MM/YYYY')}); 
              if(id !== null) {
                $.ajax({ url: "getRate", timeout: 20000, type: "POST", dataType: "json", contentType: 'application/json', data: JSON.stringify({ Analyzer: this.Analyzer.Analyzer, RateID: id }), 
                  success: function(result) {
                    this.Initial = result;
                    this.Rate = Object.assign({}, result);
                    this.Tariffs.unshift({ id: 'CURRENT', name: '(*) ' + result.Name, description: 'From ' + moment(result.StartDate).format('DD/MM/YYYY') + ' to ' + moment(result.EndDate).format('DD/MM/YYYY')});
                    this.SetTariffs();
                  }.bind(this)
                });
              } else {
                this.Initial = null;
                $(this.$refs.Base).attr('data-id', '');
                $(this.$refs.Base).val('');
                this.Rate = { StartDate: moment().startOf('year').valueOf(), EndDate: moment().endOf('year').valueOf(), Template: null, Config: {Periods: [], Taxs: [], Billing: []} };
                this.$refs.StartDate.Disable();
                this.$refs.EndDate.Disable();
                this.SetTariffs();
              }
            }.bind(this)
          });
        });
      },
      Validate: function() {
        this.Error = '';
        if(this.Rate.Template === null) {
          this.Error = 'Select a base tariff first';
          return; 
        }
        if(this.Rate.StartDate < this.Rate.Template.Seasons[0].StartDate) {
          this.Error = 'Date ranges is outside selected tariff ranges';
          return;
        }
        if(this.Rate.EndDate > this.Rate.Template.Seasons.slice(-1)[0].EndDate) {
          this.Error = 'Date ranges is outside selected tariff ranges';
          return;
        }
      },
      SetStartDate: function(date) {
        this.Rate.StartDate = date.startOf('day').valueOf();
        this.Validate();
      },
      SetEndDate: function(date) {
        this.Rate.EndDate = date.endOf('day').valueOf();
        this.Validate();
      },
      Back: function() {
        this.Show = false;
        this.$parent.$refs.Rates.Load(this.Analyzer);
      },
      FillPeriods: function() {
        this.Rate.Config.Periods.length = this.Rate.Template.Periods.length;
        for(var n = 0; n < this.Rate.Template.Periods.length; n++) this.Rate.Config.Periods[n] = Object.assign({ Contracted_Power: 0.0, Energy_Cost: 0.0, Power_Cost: 0.0 }, this.Rate.Config.Periods[n]);
      },
      SelectBase: function(e, keywork) {
        this.$refs.StartDate.Enable();
        this.$refs.EndDate.Enable();
        if(keywork.id === 'CURRENT') {
          this.LoadCurrent();
          this.Validate();
        } else {
          this.ShowSpinner = true;
          $.ajax({ url: "getTariff", timeout: 20000, type: "POST", dataType: "json", contentType: 'application/json', data: JSON.stringify({ TariffID: keywork.id }), 
            success: function(result) {
              this.Rate.Template = result.Template;
              this.Rate.Name = result.Name;
              this.FillPeriods();
              this.Validate();
              this.ShowSpinner = false;
            }.bind(this)
          });
        }
      },
      DeselectBase: function(e) {
        this.$refs.StartDate.Disable();
        this.$refs.EndDate.Disable();
        this.Error = 'Select a base tariff from list';
      },
      Periods: function() {
        this.Show = false;
        this.$parent.$refs.Periods.Load(this.Rate);
      },
      Billing: function() {
        this.Show = false;
        this.$parent.$refs.Billing.Load(this.Analyzer, this.Rate);
      }
    },
    created: function() {
      this.Tariffs = [];
      this.Initial = null;
    },
    beforeDestroy: function() {
      $(this.$refs.Base).off('onSetSelectValue', this.SelectBase.bind(this));
      $(this.$refs.Base).off('onUnsetSelectValue', this.DeselectBase.bind(this));
      $(this.$refs.Base).bsSuggest("destroy");
    },
    components: { DatePicker, Spinner }
  }
</script>

<style scoped>
  .dropdown-menu >>> .jhover {
    background: #337ab7;
  }
  .dropdown-menu >>> .table {
    margin: 4px 0px 0px 0px !important;
  }
  .dropdown-menu >>> td {
    border: none;
  }
</style>